$ set noon
$!
$ write sys$output "EQUEL/C Controller started ''f$time()'"
$!
$ debug=""
$ optimize=""
$ exe="''p1'.exe"
$ eqcflag="YES"
$ ccflag="YES"
$ libflag="NO"
$ linkflag="NO"
$ purgeflag="YES"
$ warnflag="YES"
$ objpath=""
$!
$! parse flags
$!
$ x=2
$ loop:
$! sh sym p'x'
$ if p'x' .eqs. "-C" then ccflag="NO"
$ if p'x' .eqs. "+C" then ccflag="YES"
$ if p'x' .eqs. "-D" then debug=""
$ if p'x' .eqs. "+D" then debug="/debug"
$ if p'x' .eqs. "+D" then optimize="/noopt"
$ if p'x' .eqs. "-E" then eqcflag="NO"
$ if p'x' .eqs. "+E" then eqcflag="YES"
$ if p'x' .eqs. "-L" then linkflag="NO"
$ if p'x' .eqs. "+L" then linkflag="YES"
$ if p'x' .eqs. "-P" then purgeflag="NO"
$ if p'x' .eqs. "+P" then purgeflag="YES"
$ if p'x' .eqs. "-W" then warnflag="NO"
$ if p'x' .eqs. "+W" then warnflag="YES"
$ editstr=p'x'
$ !sh sym editstr
$ if f$edit("''f$extract(0,2,editstr)'","UPCASE") .eqs. "+R" then libflag="YES"
$ if f$edit("''f$extract(0,2,editstr)'","UPCASE") .eqs. "+R" then libname=f$extract(2,f$length(editstr),editstr)
$ if f$edit("''f$extract(0,2,editstr)'","UPCASE") .eqs. "+R" then sh sym libname
$ if f$edit("''f$extract(0,2,editstr)'","UPCASE") .eqs. "-R" then libflag="NO"
$ if f$edit("''f$extract(0,2,editstr)'","UPCASE") .eqs. "+O" then objflag="YES"
$ if f$edit("''f$extract(0,2,editstr)'","UPCASE") .eqs. "+O" then objpath=f$extract(2,f$length(editstr),editstr)
$ if f$edit("''f$extract(0,2,editstr)'","UPCASE") .eqs. "+O" then sh sym objpath
$ if f$edit("''f$extract(0,2,editstr)'","UPCASE") .eqs. "-O" then objflag="NO"
$ x=x+1
$ if x .le. 8 then goto loop
$!
$ if eqcflag .eqs. "NO" then goto skip_eqc
$!
$ eqc:
$ errloc="EQUEL/C Preprocessor"
$ write sys$output "   ''errloc' for source code ''p1' started ''f$time()'"
$ define/user sys$output 'p1'.xl
$ eqc -n.qh -o.xh -# -d -f'p1'.xc 'p1'.qc
$ stat=$status
$ write sys$output "   ''errloc' finished ''f$time()'"
$ if stat .ge. %x10000000 then stat=stat-%x10000000
$ if stat .ne. 1 .and. stat .ne. %x2c .and. stat .ne. %x3B then goto abort
$ size=f$file("''p1'.xl","EOF")
$ if size .eq. 0 then goto cc
$ write sys$output "Preprocessor Errors:"
$ type/page 'p1'.xl
$ goto done
$ skip_eqc:
$!
$ cc:
$ if ccflag .eqs. "NO" then goto skip_cc
$ errloc="VAX/C Compiler"
$ write sys$output "   ''errloc' for source code ''p1' started ''f$time()'"
$ warn=""
$ if warnflag .eqs. "NO" then warn="/NOWARN"
$ if debug .nes. "" then write sys$output "Debug is on"
$ cc'debug''optimize''warn'/lis='p1'.lst/obj='objpath''p1'.obj 'p1'.xc
$ stat=$status
$ write sys$output "   ''errloc' finished ''f$time()'"
$ if stat .ne. %x10b90001 .and. stat .ne. %x10b90000 then goto abort
$ skip_cc:
$!
$ lib:
$ errloc="VAX Librarian"
$ if libflag .eqs. "NO" then goto skip_lib
$ !sh sym libname
$ libfile=f$parse(libname,"*.olb")
$ if f$search(libfile) .eqs. "" then library/create/log/obj 'libname'
$ library/repl/log 'libname' 'objpath''p1'.obj
$ skip_lib:
$!
$ link:
$ errloc="VAX Linker"
$ if linkflag .eqs. "NO" then goto skip_link
$ write sys$output "   ''errloc' started ''f$time()'"
$ if debug .nes. "" then write sys$output "Debug is on"
$ define/user sys$output 'p1'.lnkout
$ link'debug'/exe='exe' 'objpath''p1','objpath''p1'/opt
$ stat=$status
$ write sys$output "   ''errloc' finished ''f$time()'"
$ if stat .ne. 1 then goto abort
$ size=f$file("''p1'.lnkout","EOF")
$ if size .eq. 0 then goto cc
$ write sys$output "Linker Errors:"
$ type/page 'p1'.out
$ skip_link:
$!
$ goto done
$!
$ abort:
$ write sys$output "Error from ''errloc': ''stat'"
$!
$ done:
$ if purgeflag .eqs. "YES" then purge/log 'p1'.*
$ write sys$output "EQUEL/C Controller finished ''f$time()'"
$ exit
